#include "all.h"
const u8 WS2812B_PwrUnit_R = 0x10; //
const u8 WS2812B_PwrUnit_G = 0x10;
const u8 WS2812B_PwrUnit_B = 0x10;

extern u8 WS2812B_R[];
extern u8 WS2812B_G[];
extern u8 WS2812B_B[];
u8 WS2812B_SPI_Data[WS2812B_LEDsNum * 12];

void WS2812B_Init()
{
	u16 WS2812B_SPI_Data_First_Addr;
	WS2812B_SPI_Data_First_Addr = (u16)&WS2812B_SPI_Data[0];
	
	P2M0 = (P2M0 & ~0x34) | 0x08;
	P2M1 &= ~0x3c;
	
	HSCLKDIV = 0x05;
	SPCTL = 0xD7;
	P_SW1 = 0x04;
	
	
	DMA_SPI_TXAH = (u8)(WS2812B_SPI_Data_First_Addr >> 8);
	DMA_SPI_TXAL = (u8)WS2812B_SPI_Data_First_Addr;
	DMA_SPI_AMTH = (u8)(((WS2812B_LEDsNum * 12) - 1) / 256);
	DMA_SPI_AMT = (u8)(((WS2812B_LEDsNum * 12) - 1) % 256);
	DMA_SPI_STA = 0x00;
	DMA_SPI_CFG = 0x4A;
	DMA_SPI_CFG2 = 0x00;
	DMA_SPI_CR = 0x80;
	
	WS2812B_Reset();
}

void WS2812B_WriteLEDs(u16 Target_Power)
{
	
	u16 Current_Power = 0;
	float Brightness;
	u8 i,j,k;
	
	if(Target_Power > 10000) //
	{
		Target_Power = 10000;
	}
	for(i = 0; i < WS2812B_LEDsNum; i++)
	{
		Current_Power += (WS2812B_R[i] * WS2812B_PwrUnit_R);
		Current_Power += (WS2812B_G[i] * WS2812B_PwrUnit_G);
		Current_Power += (WS2812B_B[i] * WS2812B_PwrUnit_B);
	}

	Brightness = 1.0;
	if(Current_Power > Target_Power)
	{
		Brightness = ((float)Target_Power / (float)Current_Power);
	}
	
	for(i = 0; i < WS2812B_LEDsNum; i++)
	{
		u8 R = (u8)((WS2812B_R[i] * Brightness) + 0.5);
		u8 G = (u8)((WS2812B_G[i] * Brightness) + 0.5);
		u8 B = (u8)((WS2812B_B[i] * Brightness) + 0.5);
		
		j = 0x80;
		for(k =0; k < 8; k++) //(i)յ (3i)Byte() (8 * 3i + k)Bit
		{
			if((G & j) == j) //BitΪ1
			{
				if((k % 2) == 0) //BitӦSPIByteĸλ
				{
					WS2812B_SPI_Data[(8 * (3 * i) + k) / 2] = 0xE0;
				}
				else //BitӦSPIByteĵλ
				{
					WS2812B_SPI_Data[(8 * (3 * i) + k) / 2] |= 0x0E;
				}
			}
			else //BitΪ0
			{
				if((k % 2) == 0) //BitӦSPIByteĸλ
				{
					WS2812B_SPI_Data[(8 * (3 * i) + k) / 2] = 0x80;
				}
				else //BitӦSPIByteĵλ
				{
					WS2812B_SPI_Data[(8 * (3 * i) + k) / 2] |= 0x08;
				}
			}
			j = j >> 1;
		}
		
		j = 0x80;
		for(k =0; k < 8; k++) //(i)յ (3i + 1)Byte() (8 * (3i + 1) + k)Bit
		{
			if((R & j) == j) //BitΪ1
			{
				if((k % 2) == 0) //BitӦSPIByteĸλ
				{
					WS2812B_SPI_Data[(8 * (3 * i + 1) + k) / 2] = 0xE0;
				}
				else //BitӦSPIByteĵλ
				{
					WS2812B_SPI_Data[(8 * (3 * i + 1) + k) / 2] |= 0x0E;
				}
			}
			else //BitΪ0
			{
				if((k % 2) == 0) //BitӦSPIByteĸλ
				{
					WS2812B_SPI_Data[(8 * (3 * i + 1) + k) / 2] = 0x80;
				}
				else //BitӦSPIByteĵλ
				{
					WS2812B_SPI_Data[(8 * (3 * i + 1) + k) / 2] |= 0x08;
				}
			}
			j = j >> 1;
		}
		
		j = 0x80;
		for(k =0; k < 8; k++) //(i)յ (3i + 2)Byte() (8 * (3i + 2) + k)Bit
		{
			if((B & j) == j) //BitΪ1
			{
				if((k % 2) == 0) //BitӦSPIByteĸλ
				{
					WS2812B_SPI_Data[(8 * (3 * i + 2) + k) / 2] = 0xE0;
				}
				else //BitӦSPIByteĵλ
				{
					WS2812B_SPI_Data[(8 * (3 * i + 2) + k) / 2] |= 0x0E;
				}
			}
			else //BitΪ0
			{
				if((k % 2) == 0) //BitӦSPIByteĸλ
				{
					WS2812B_SPI_Data[(8 * (3 * i + 2) + k) / 2] = 0x80;
				}
				else //BitӦSPIByteĵλ
				{
					WS2812B_SPI_Data[(8 * (3 * i + 2) + k) / 2] |= 0x08;
				}
			}
			j = j >> 1;
		}
	}
	
	DMA_SPI_CR |= 0x40;
}

void WS2812B_Reset()
{
	u8 i = 0;
	for(i = 0; i < WS2812B_LEDsNum; i++)
	{
		 WS2812B_R[i] = 0;
     WS2812B_G[i] = 0;
     WS2812B_B[i] = 0;
	}
	WS2812B_WriteLEDs(10000);
}